using System.Collections.Generic;
using cocos2d;

namespace $safeprojectname$
{
    public class HelloCocos2dScene : CCScene
    {
        static HelloCocos2dScene _scene;
        public static HelloCocos2dScene scene()
        {
            if (_scene == null)
                _scene = new HelloCocos2dScene();
            return _scene;
        }
        private HelloCocos2dScene()
        {
            init();
        }
        CCLayer layer;
        /// <summary>
        ///  Here's a difference. Method 'init' in cocos2d-x returns bool, instead of returning 'id' in cocos2d-iphone
        /// </summary>
        public new bool init()
        {
            if (base.init() == false)
                return false;
            layer = new CCLayer();
            CCDirector.sharedDirector().deviceOrientation = ccDeviceOrientation.CCDeviceOrientationLandscapeLeft;

            CCSize size = CCDirector.sharedDirector().getWinSize();
            if (!base.init())
            {
                return false;
            }

            layer.isTouchEnabled = true;

            CCMenuItemImage pCloseItem = CCMenuItemImage.itemFromNormalImage(
                                                "CloseNormal",
                                                "CloseSelected",
                                                this,
                                                new SEL_MenuHandler(menuCloseCallback));
            pCloseItem.position = new CCPoint(CCDirector.sharedDirector().getWinSize().width - 20, 20);

            CCMenu pMenu = CCMenu.menuWithItems(pCloseItem);
            pMenu.position = new CCPoint(0, 0);
            layer.addChild(pMenu, 1);

            CCLabelTTF pLabel = CCLabelTTF.labelWithString("Hello World", "Arial", 24);

            pLabel.position = new CCPoint(size.width / 2, size.height - 50);

            layer.addChild(pLabel, 1);

            CCSprite pSprite = CCSprite.spriteWithFile("HelloWorld");


	        pSprite.position = new CCPoint(size.width/2, size.height/2);

            layer.addChild(pSprite, 0);
            this.addChild(layer);
	        return true;
        }


        /// <summary>
        /// a selector callback
        /// </summary>
        /// <param name="pSender"></param>
        public virtual void menuCloseCallback(CCObject pSender)
        {
            CCDirector.sharedDirector().end();
            CCApplication.sharedApplication().Game.Exit();
        }

    }
}
